/* Pong - A version of Pong based on Ncurses
 * Copyright (C) 1999 Jeffrey Wade Starr <starr81@ix.netcom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */   

// controls.h
// Specification for the keys used to control the game
// By Jeffrey W. Starr Oct 20 1998

#ifndef CONTROLS_H
#define CONTROLS_H

#include <string.h>

char LEFT     = 'a';
char RIGHT    = 'l';
char PAUSE    = 'p';
char FASTER   = '+';
char SLOWER   = '-';
char REALSLOW = '_';
char QUIT     = 'q';
bool SOUND    = true;


void Keybmod(int argc, char *argv[])
{
  char buff[2];

  for(int i = 0; i < argc; ++i)
    {
      if( strcmp(argv[i], "-left") == 0 )
	{
	  strncpy( buff, argv[i+1], 1);
	  LEFT = buff[0];
	}

      if( strcmp(argv[i], "-right") == 0 )
	{
	  strncpy( buff, argv[i+1], 1);
	  RIGHT = buff[0];
	}

      if( strcmp(argv[i], "-pause") == 0 )
	{
	  strncpy( buff, argv[i+1], 1);
	  PAUSE = buff[0];
	}

      if( strcmp(argv[i], "-quit") == 0 )
	{
	  strncpy( buff, argv[i+1], 1);
	  QUIT = buff[0];
	}

      if( strcmp(argv[i], "-faster") == 0 )
	{
	  strncpy( buff, argv[i+1], 1);
	  FASTER = buff[0];
	}

      if( strcmp(argv[i], "-slower") == 0 )
	{
	  strncpy( buff, argv[i+1], 1);
	  SLOWER = buff[0];
	}

      if( strcmp(argv[i], "-realslow") == 0 )
	{
	  strncpy( buff, argv[i+1], 1);
	  REALSLOW = buff[0];
	}

      if( strcmp(argv[i], "-nosound") == 0 )
	{
	  SOUND = false;
	}

      if( strcmp(argv[i], "-dumpkeys") == 0 )
	{
	  nocrmode();
	  echo();
	  endwin();

	  cout << "Right\t" << RIGHT << "\tLeft\t" << LEFT << endl;
	  cout << "Pause\t" << PAUSE << "\tQuit\t" << QUIT << endl;
	  cout << "Faster\t" << FASTER << "\tSlower\t" << SLOWER << endl;
	  cout << "Realslow\t" << REALSLOW << endl;

	  exit(0);
	}

      if( strcmp(argv[i], "--help") == 0 || strcmp(argv[i], "-help") == 0 )
	{
	  // clean up after ncurses screen initialization
	  nocrmode();
	  echo();
	  endwin();

	  cout << "Syntax: pong [options]" << endl;
	  cout << "\t-left\t\tSet the key to move the paddle to the left\n";
	  cout << "\t-right\t\tSet the key to move the paddle to the right\n";
	  cout << "\t-pause\t\tSet the key to pause the game\n";
	  cout << "\t-quit\t\tSet the key to quit the game\n";
	  cout << "\t-faster\t\tSet the key to increase the game speed\n";
	  cout << "\t-slower\t\tSet the key to decrease the game speed\n";
	  cout << "\t-realslow\tSlow the game enourmously; mainly for debugging\n";
	  cout << "\t-nosound\tTurn playing sound effects through sox(1) off\n";
	  cout << "\t-dumpkeys\tDisplay the default keys for operating the game\n";
	  cout << "Example: pong -left j -right k -nosound\n";
	  exit(0);
	}
    }
}

#endif

